<a id="types-aiobotocore-accessanalyzer"></a>

# types-aiobotocore-accessanalyzer

[![PyPI - types-aiobotocore-accessanalyzer](https://img.shields.io/pypi/v/types-aiobotocore-accessanalyzer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-accessanalyzer)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-accessanalyzer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-accessanalyzer)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_accessanalyzer/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-accessanalyzer?color=blue)](https://pypistats.org/packages/types-aiobotocore-accessanalyzer)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.AccessAnalyzer 2.5.2](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/accessanalyzer.html#AccessAnalyzer)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.14.5](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-accessanalyzer docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_accessanalyzer/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-accessanalyzer](#types-aiobotocore-accessanalyzer)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `AccessAnalyzer` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[accessanalyzer]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[accessanalyzer]'


# standalone installation
python -m pip install types-aiobotocore-accessanalyzer
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-accessanalyzer
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[accessanalyzer]` in your environment:

```bash
python -m pip install 'types-aiobotocore[accessanalyzer]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[accessanalyzer]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[accessanalyzer]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[accessanalyzer]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[accessanalyzer]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[accessanalyzer]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[accessanalyzer]` in your environment:

```bash
python -m pip install 'types-aiobotocore[accessanalyzer]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[accessanalyzer]` in your environment:

```bash
python -m pip install 'types-aiobotocore[accessanalyzer]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`AccessAnalyzerClient` provides annotations for
`session.create_client("accessanalyzer")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_accessanalyzer import AccessAnalyzerClient

session = get_session()
async with session.create_client("accessanalyzer") as client:
    client: AccessAnalyzerClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_accessanalyzer.paginator` module contains type annotations
for all paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_accessanalyzer import AccessAnalyzerClient
from types_aiobotocore_accessanalyzer.paginator import (
    ListAccessPreviewFindingsPaginator,
    ListAccessPreviewsPaginator,
    ListAnalyzedResourcesPaginator,
    ListAnalyzersPaginator,
    ListArchiveRulesPaginator,
    ListFindingsPaginator,
    ListPolicyGenerationsPaginator,
    ValidatePolicyPaginator,
)

session = get_session()
async with session.create_client("accessanalyzer") as client:
    client: AccessAnalyzerClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    list_access_preview_findings_paginator: ListAccessPreviewFindingsPaginator = (
        client.get_paginator("list_access_preview_findings")
    )
    list_access_previews_paginator: ListAccessPreviewsPaginator = client.get_paginator(
        "list_access_previews"
    )
    list_analyzed_resources_paginator: ListAnalyzedResourcesPaginator = client.get_paginator(
        "list_analyzed_resources"
    )
    list_analyzers_paginator: ListAnalyzersPaginator = client.get_paginator("list_analyzers")
    list_archive_rules_paginator: ListArchiveRulesPaginator = client.get_paginator(
        "list_archive_rules"
    )
    list_findings_paginator: ListFindingsPaginator = client.get_paginator("list_findings")
    list_policy_generations_paginator: ListPolicyGenerationsPaginator = client.get_paginator(
        "list_policy_generations"
    )
    validate_policy_paginator: ValidatePolicyPaginator = client.get_paginator("validate_policy")
```

<a id="literals"></a>

### Literals

`types_aiobotocore_accessanalyzer.literals` module contains literals extracted
from shapes that can be used in user code for type checking.

```python
from types_aiobotocore_accessanalyzer.literals import (
    AccessPreviewStatusReasonCodeType,
    AccessPreviewStatusType,
    AclPermissionType,
    AnalyzerStatusType,
    FindingChangeTypeType,
    FindingSourceTypeType,
    FindingStatusType,
    FindingStatusUpdateType,
    JobErrorCodeType,
    JobStatusType,
    KmsGrantOperationType,
    ListAccessPreviewFindingsPaginatorName,
    ListAccessPreviewsPaginatorName,
    ListAnalyzedResourcesPaginatorName,
    ListAnalyzersPaginatorName,
    ListArchiveRulesPaginatorName,
    ListFindingsPaginatorName,
    ListPolicyGenerationsPaginatorName,
    LocaleType,
    OrderByType,
    PolicyTypeType,
    ReasonCodeType,
    ResourceTypeType,
    TypeType,
    ValidatePolicyFindingTypeType,
    ValidatePolicyPaginatorName,
    ValidatePolicyResourceTypeType,
    AccessAnalyzerServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: AccessPreviewStatusReasonCodeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_accessanalyzer.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_accessanalyzer.type_defs import (
    AccessPreviewStatusReasonTypeDef,
    AclGranteeTypeDef,
    AnalyzedResourceSummaryTypeDef,
    AnalyzedResourceTypeDef,
    StatusReasonTypeDef,
    ApplyArchiveRuleRequestRequestTypeDef,
    CriterionTypeDef,
    CancelPolicyGenerationRequestRequestTypeDef,
    TrailTypeDef,
    TrailPropertiesTypeDef,
    EbsSnapshotConfigurationTypeDef,
    EcrRepositoryConfigurationTypeDef,
    EfsFileSystemConfigurationTypeDef,
    IamRoleConfigurationTypeDef,
    SecretsManagerSecretConfigurationTypeDef,
    SnsTopicConfigurationTypeDef,
    SqsQueueConfigurationTypeDef,
    ResponseMetadataTypeDef,
    DeleteAnalyzerRequestRequestTypeDef,
    DeleteArchiveRuleRequestRequestTypeDef,
    FindingSourceDetailTypeDef,
    GeneratedPolicyTypeDef,
    GetAccessPreviewRequestRequestTypeDef,
    GetAnalyzedResourceRequestRequestTypeDef,
    GetAnalyzerRequestRequestTypeDef,
    GetArchiveRuleRequestRequestTypeDef,
    GetFindingRequestRequestTypeDef,
    GetGeneratedPolicyRequestRequestTypeDef,
    JobErrorTypeDef,
    KmsGrantConstraintsTypeDef,
    PaginatorConfigTypeDef,
    ListAccessPreviewsRequestRequestTypeDef,
    ListAnalyzedResourcesRequestRequestTypeDef,
    ListAnalyzersRequestRequestTypeDef,
    ListArchiveRulesRequestRequestTypeDef,
    SortCriteriaTypeDef,
    ListPolicyGenerationsRequestRequestTypeDef,
    PolicyGenerationTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    VpcConfigurationTypeDef,
    SubstringTypeDef,
    PolicyGenerationDetailsTypeDef,
    PositionTypeDef,
    RdsDbClusterSnapshotAttributeValueTypeDef,
    RdsDbSnapshotAttributeValueTypeDef,
    S3PublicAccessBlockConfigurationTypeDef,
    StartResourceScanRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateFindingsRequestRequestTypeDef,
    ValidatePolicyRequestRequestTypeDef,
    AccessPreviewSummaryTypeDef,
    S3BucketAclGrantConfigurationTypeDef,
    AnalyzerSummaryTypeDef,
    ArchiveRuleSummaryTypeDef,
    CreateArchiveRuleRequestRequestTypeDef,
    InlineArchiveRuleTypeDef,
    ListAccessPreviewFindingsRequestRequestTypeDef,
    UpdateArchiveRuleRequestRequestTypeDef,
    CloudTrailDetailsTypeDef,
    CloudTrailPropertiesTypeDef,
    CreateAccessPreviewResponseTypeDef,
    CreateAnalyzerResponseTypeDef,
    EmptyResponseMetadataTypeDef,
    GetAnalyzedResourceResponseTypeDef,
    ListAnalyzedResourcesResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    StartPolicyGenerationResponseTypeDef,
    FindingSourceTypeDef,
    JobDetailsTypeDef,
    KmsGrantConfigurationTypeDef,
    ListAccessPreviewFindingsRequestListAccessPreviewFindingsPaginateTypeDef,
    ListAccessPreviewsRequestListAccessPreviewsPaginateTypeDef,
    ListAnalyzedResourcesRequestListAnalyzedResourcesPaginateTypeDef,
    ListAnalyzersRequestListAnalyzersPaginateTypeDef,
    ListArchiveRulesRequestListArchiveRulesPaginateTypeDef,
    ListPolicyGenerationsRequestListPolicyGenerationsPaginateTypeDef,
    ValidatePolicyRequestValidatePolicyPaginateTypeDef,
    ListFindingsRequestListFindingsPaginateTypeDef,
    ListFindingsRequestRequestTypeDef,
    ListPolicyGenerationsResponseTypeDef,
    NetworkOriginConfigurationTypeDef,
    PathElementTypeDef,
    SpanTypeDef,
    RdsDbClusterSnapshotConfigurationTypeDef,
    RdsDbSnapshotConfigurationTypeDef,
    ListAccessPreviewsResponseTypeDef,
    GetAnalyzerResponseTypeDef,
    ListAnalyzersResponseTypeDef,
    GetArchiveRuleResponseTypeDef,
    ListArchiveRulesResponseTypeDef,
    CreateAnalyzerRequestRequestTypeDef,
    StartPolicyGenerationRequestRequestTypeDef,
    GeneratedPolicyPropertiesTypeDef,
    AccessPreviewFindingTypeDef,
    FindingSummaryTypeDef,
    FindingTypeDef,
    KmsKeyConfigurationTypeDef,
    S3AccessPointConfigurationTypeDef,
    LocationTypeDef,
    GeneratedPolicyResultTypeDef,
    ListAccessPreviewFindingsResponseTypeDef,
    ListFindingsResponseTypeDef,
    GetFindingResponseTypeDef,
    S3BucketConfigurationTypeDef,
    ValidatePolicyFindingTypeDef,
    GetGeneratedPolicyResponseTypeDef,
    ConfigurationTypeDef,
    ValidatePolicyResponseTypeDef,
    AccessPreviewTypeDef,
    CreateAccessPreviewRequestRequestTypeDef,
    GetAccessPreviewResponseTypeDef,
)


def get_structure() -> AccessPreviewStatusReasonTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-accessanalyzer` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_accessanalyzer/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
